package com.like.server;

import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Request {//请求
	private InputStream is;//输入流
	private String requestInfo;//请求字符串，请求方式，请求路径，参数，协议，协议版本，请求的正文
	private String method;//请求的方式
	private String url;//请求的url
	public String getUrl() {
		return url;
	}
	//输入框的name为key，值为value
	/**
	 * key:username   value:bjsxt
	 * key:pwd        value:123
	 * key:hobby      value:read,ball
	 */
	private Map<String,List<String>> paramtermapValues;//参数
	private static final String CRLF="\r\n";//换行
	private static final String BLANK=" ";//空格
	//构造方法，初始化属性
	public Request() {
		paramtermapValues=new HashMap<String,List<String>>();
		method="";
		url="";
		requestInfo="";
	}
	public Request(InputStream is) {
		this();
		this.is=is;
		try {
			byte[] buf=new byte[20480];
			int len=this.is.read(buf);
			requestInfo=new String(buf,0,len);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			return;
		}
		this.parseRequestInfo();
	}
	private void parseRequestInfo() {
		String parseString="";//用于存储请求参数
		//获取请求参数的第一行
		String firstLine=requestInfo.substring(0, requestInfo.indexOf(CRLF)).trim();//从零开始到第一个换行的位置
		//分解出请求方式
		int index=firstLine.indexOf("/");
		String method=firstLine.substring(0,index).trim();
		//分解URl，get可能包含的参数，也可能不包含参数post
		String urlString=firstLine.substring(index, firstLine.indexOf("HTTP/")).trim();
		//判断请求方式是GET还是POST
		if("get".equalsIgnoreCase(this.method)) {
			if(urlString.contains("?")) {
				String [] urlArray=urlString.split("\\?");//split()把一个字符串分成字符串数组
				this.url=urlArray[0];
				parseString=urlArray[1];
			}else {
				this.url=urlString;
			}
		}else {//post不包含参数请求
			this.url=urlString;
			parseString=requestInfo.substring(requestInfo.lastIndexOf(CRLF)).trim();
		}
		if(parseString.equals("")) {
			return;
		};
		this.parseParam(parseString);
		//请求参数
		System.out.println(parseString);
	}
	//用于测试
	public void show() {
		System.out.println(this.url);
		System.out.println(this.method);
	}
	
	/**
	 * username=bjsxt
	 * pwd=123
	 * hoby=ball
	 * hoby=paint
	 * @param pararString
	 */
	private void parseParam(String prarString) {
		String[] token=prarString.split("&");
		for (int i = 0; i < token.length; i++) {
			String keyValues=token[i];
			String[] keyValue=keyValues.split("=");
			if(keyValue.length==1) {
				keyValue=Arrays.copyOf(keyValue, 2);
				keyValue[1]=null;
			}
			//将表单元素的name与name相对应的值存储在Map集合中
			String key=keyValue[0].trim();
			String value=keyValue[1]==null?null:decode(keyValue[1].trim(),"utf-8");
			//放到集合中储存
			if(!paramtermapValues.containsKey(key)) {
				paramtermapValues.put(key,new ArrayList<String>());
			}
			List<String> values=paramtermapValues.get(key);
			values.add(value);
		}
	}
	//根据表单元素的name获取多个值
	public String[] getparamterValues(String name) {
		//根据key获取value
		List<String> values=paramtermapValues.get(name);
		if(values==null) {
			return null;
		}else {
			return values.toArray(new String[0]);
		}
	}
	public String getparamter(String name) {
		//调用本类中根据name获取多个值的方法
		String [] values=this.getparamterValues(name);
		if(values==null) {
			return null;
		}else {
			return values[0];
		}
	}
	//处理中文，因为浏览器对中文进行了编码，进行解码
	private String decode(String value, String code) {
		try {
			return URLDecoder.decode(value, code);
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	public static void main(String[] args) {
		Request req=new Request();
		//调用分解参数的方法
		req.parseParam("username=%E5%8C%97%E4%BA%AC%E5%B0%9A%E5%AD%A6%E5%A0%82&pwd=123&hobby=ball&hobby=paint");
		System.out.println(req.paramtermapValues);
		//调用取多个值的方法
		String [] str=req.getparamterValues("hobby");
		for (String string : str) {
			System.out.print(string+"\t");
		}
		System.out.println("\n");
		//调用取一个值的方法
		System.out.println(req.getparamter("pwd"));
	}
}
