package com.like.server;

import java.util.List;
import java.util.Map;

import com.like.servlet.Servlet;

public class WebApp {//app的意思是应用程序
	private static ServletContext contxt;
	static {
		contxt=new ServletContext();
		//分别获取对应关系的集合
		Map<String,String> servlet=contxt.getServlet();
		Map<String,String> mapping=contxt.getMapping();
		//创建解析xml文件对象
		WebDom4j web=new WebDom4j();
		web.parse(web.getDocument());
		//获取解析xml之后的List集合
		List<Entity> entityList=web.getEntityList();
		List<Mapping> mappingList=web.getMappingList();
		//将List集合中的数据存储在Map集合中
		for (Entity entity : entityList) {
			servlet.put(entity.getName(), entity.getClazz());
		}
		for (Mapping map : mappingList) {
			//遍历url-pattern的集合
			List<String> urlPattern=map.getUrlPattern();
			for (String s : urlPattern) {
				mapping.put(s, map.getName());
			}
		}
		//System.out.println(mapping);
	}
	/**
	 * 根据url创建不同的Servlet对象
	 * @param url
	 * @return
	 */
	public static Servlet getServlet(String url) {
		if(url==null||url.trim().equals("")) {
			return null;
		}
		try {
			//根据url的key获取servlet-name的值 /log=login, /reg=regester
			String servletName=contxt.getMapping().get(url);
			String servletClass=contxt.getServlet().get(servletName);//得到的是一个完整的包名加类名的字符串
			//使用反射创建Servlet对象
			Class<?> clazz=Class.forName(servletClass);
			//调用无参构造方法创建Servlet对象
			Servlet servlet=(Servlet) clazz.newInstance(); 
			return servlet;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	/*//测试
	public static void main(String[] args) {
		System.out.println(getServlet("/log"));
	}*/
}
