package com.like.server;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

public class WebDom4j {//用于解析xml
	private List<Entity> entityList;//用于储存多个Entity，而每一个Entity都是servlet-name与servlet-class
	private List<Mapping> mappingList;//用于储存多个Mapping，而每一个都是一个servlet-name与多url-pattern
	public List<Entity> getEntityList() {
		return entityList;
	}
	public void setEntityList(List<Entity> entityList) {
		this.entityList = entityList;
	}
	public List<Mapping> getMappingList() {
		return mappingList;
	}
	public void setMappingList(List<Mapping> mappingList) {
		this.mappingList = mappingList;
	}
	//构造方法
	public WebDom4j() {
		entityList=new ArrayList<Entity>();
		mappingList=new ArrayList<Mapping>();
	}
	//获取Document对象
	public Document getDocument() {
		//(1)创建SAXReader对象
		SAXReader reader=new SAXReader();
		try {
			return reader.read(new File("src/WEB_INFO/web.xml"));
		} catch (DocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	public void parse(Document doc) {
		//获取根元素
		Element root=doc.getRootElement();//web-app
		//(2)获取servlet子元素
		for(Iterator<Element> ite=root.elementIterator("servlet");ite.hasNext();) {
			Element subElement=ite.next();//得到每一个servlet元素
			Entity ent=new Entity();
			Iterator<Element> ele=subElement.elementIterator();
			while(ele.hasNext()) {
				Element subite=ele.next();//可能是servlet-name，也有可能是servlet-class
				if("servlet-name".equals(subite.getName())) {
					ent.setName(subite.getText());
				}else if("servlet-class".equals(subite.getName())) {
					ent.setClazz(subite.getText());
				}
			}
			//将Entity添加到集合中
			entityList.add(ent);
		}
		//用于测试
		/*System.out.println("entiyList中元素个数："+entityList.size());
		for (Entity e : entityList) {
			System.out.println(e.getName()+"\t"+e.getClazz());
		}*/
		//(3)获取servlet-mapping元素
		for(Iterator<Element> ite=root.elementIterator("servlet-mapping");ite.hasNext();) {
			Element subElement=ite.next();
			Mapping map=new Mapping();
			for(Iterator<Element> subele=subElement.elementIterator();subele.hasNext();) {
				Element ele=subele.next();
				if("servlet-name".equals(ele.getName())) {
					map.setName(ele.getText());
				}else if("url-pattern".equals(ele.getName())) {
					map.getUrlPattern().add(ele.getText());
				}
			}
			//将Mapping添加到集合中
			mappingList.add(map);
		}
		/*//用于测试
		System.out.println("mappingList中的元素个数："+mappingList.size());
		for (Mapping m : mappingList) {
			System.out.println(m.getName()+"\t"+m.getUrlPattern());
		}*/
	}
	//用于测试
	/*public static void main(String[] args) {
		WebDom4j web=new WebDom4j();
		web.parse(web.getDocument());
	}*/
}
